(function(f){if(typeof exports==="object"&&typeof module!=="undefined"){module.exports=f()}else if(typeof define==="function"&&define.amd){define([],f)}else{var g;if(typeof window!=="undefined"){g=window}else if(typeof global!=="undefined"){g=global}else if(typeof self!=="undefined"){g=self}else{g=this}g.panoptoSchedulerPluginExtension = f()}})(function(){var define,module,exports;return (function(){function r(e,n,t){function o(i,f){if(!n[i]){if(!e[i]){var c="function"==typeof require&&require;if(!f&&c)return c(i,!0);if(u)return u(i,!0);var a=new Error("Cannot find module '"+i+"'");throw a.code="MODULE_NOT_FOUND",a}var p=n[i]={exports:{}};e[i][0].call(p.exports,function(r){var n=e[i][1][r];return o(n||r)},p,p.exports,r,e,n,t)}return n[i].exports}for(var u="function"==typeof require&&require,i=0;i<t.length;i++)o(t[i]);return o}return r})()({1:[function(require,module,exports){

},{}],2:[function(require,module,exports){
const _ = require("lodash");
const ko = require("knockout");
const toastr = require("toastr");

const settingsForm = require("./settings.pug");
const SettingsForm = require("./plugins/settingsForm");

function PanoptoSchedulerExtension (plugin)
{
    let status = ko.observable({
        success: false,
        enabled: false,
        message: "Unknown",
        timestamp: -1,
        registered: false,
        resourceName: null
    });

    const {capturecastEventSource} = require("./environment");
    capturecastEventSource.addEventListener("PanoptoSchedulerStatusEvent", event => {
        status(event.status);
    });

    function refreshStatus ()
    {
        return plugin.services["getStatus"]({}).then(returnStatus => {
            status(returnStatus);
            return returnStatus;
        });
    }

    plugin.refresh = function refresh ()
    {
        return plugin.services["refresh"]({}).then(returnStatus => {
            status(returnStatus);
            if (returnStatus.success)
            {
                toastr.success(`Panopto Scheduler was refreshed successfully: ${returnStatus.message}`);
            }
            else
            {
                toastr.error(`Panopto Scheduler was not refreshed successfully: ${returnStatus.message}`);
            }
        });
    };

    plugin.status = status;
    plugin.settingsForm = SettingsForm(plugin, settingsForm, [
        "url",
        "registration-key",
        "poll-period-sec"
    ], function (parent) {
        const {makeMoment} = require("./time");
        this.status = status;
        this.lastUpdated = ko.computed(() => makeMoment(status().timestamp));
        
        this.url.extend({
            required: true
        });
        this.registrationKey.extend({
            required: true
        });
    });

    refreshStatus();
    return plugin;
}

module.exports = PanoptoSchedulerExtension;

},{"./environment":undefined,"./plugins/settingsForm":undefined,"./settings.pug":3,"./time":undefined,"knockout":"knockout","lodash":"lodash","toastr":undefined}],3:[function(require,module,exports){
var pug = require('pug-runtime');
module.exports=template;function pug_attr(t,e,n,r){if(!1===e||null==e||!e&&("class"===t||"style"===t))return"";if(!0===e)return" "+(r?t:t+'="'+t+'"');var f=typeof e;return"object"!==f&&"function"!==f||"function"!=typeof e.toJSON||(e=e.toJSON()),"string"==typeof e||(e=JSON.stringify(e),n||-1===e.indexOf('"'))?(n&&(e=pug_escape(e))," "+t+'="'+e+'"'):" "+t+"='"+e.replace(/'/g,"&#39;")+"'"}
function pug_attrs(t,r){var a="";for(var s in t)if(pug_has_own_property.call(t,s)){var u=t[s];if("class"===s){u=pug_classes(u),a=pug_attr(s,u,!1,r)+a;continue}"style"===s&&(u=pug_style(u)),a+=pug_attr(s,u,!1,r)}return a}
function pug_classes(s,r){return Array.isArray(s)?pug_classes_array(s,r):s&&"object"==typeof s?pug_classes_object(s):s||""}
function pug_classes_array(r,a){for(var s,e="",u="",c=Array.isArray(a),g=0;g<r.length;g++)(s=pug_classes(r[g]))&&(c&&a[g]&&(s=pug_escape(s)),e=e+u+s,u=" ");return e}
function pug_classes_object(r){var a="",n="";for(var o in r)o&&r[o]&&pug_has_own_property.call(r,o)&&(a=a+n+o,n=" ");return a}
function pug_escape(e){var a=""+e,t=pug_match_html.exec(a);if(!t)return e;var r,c,n,s="";for(r=t.index,c=0;r<a.length;r++){switch(a.charCodeAt(r)){case 34:n="&quot;";break;case 38:n="&amp;";break;case 60:n="&lt;";break;case 62:n="&gt;";break;default:continue}c!==r&&(s+=a.substring(c,r)),c=r+1,s+=n}return c!==r?s+a.substring(c,r):s}
var pug_has_own_property=Object.prototype.hasOwnProperty;
var pug_match_html=/["&<>]/;
function pug_merge(e,r){if(1===arguments.length){for(var t=e[0],g=1;g<e.length;g++)t=pug_merge(t,e[g]);return t}for(var l in r)if("class"===l){var n=e[l]||[];e[l]=(Array.isArray(n)?n:[n]).concat(r[l]||[])}else if("style"===l){var n=pug_style(e[l]);n=n&&";"!==n[n.length-1]?n+";":n;var a=pug_style(r[l]);a=a&&";"!==a[a.length-1]?a+";":a,e[l]=n+a}else e[l]=r[l];return e}
function pug_rethrow(n,e,r,t){if(!(n instanceof Error))throw n;if(!("undefined"==typeof window&&e||t))throw n.message+=" on line "+r,n;try{t=t||require("fs").readFileSync(e,"utf8")}catch(e){pug_rethrow(n,null,r)}var i=3,a=t.split("\n"),o=Math.max(r-i,0),h=Math.min(a.length,r+i),i=a.slice(o,h).map(function(n,e){var t=e+o+1;return(t==r?"  > ":"    ")+t+"| "+n}).join("\n");throw n.path=e,n.message=(e||"Pug")+":"+r+"\n"+i+"\n\n"+n.message,n}
function pug_style(r){if(!r)return"";if("object"==typeof r){var t="";for(var e in r)pug_has_own_property.call(r,e)&&(t=t+e+":"+r[e]+";");return t}return r+""}function template(locals) {var pug_html = "", pug_mixins = {}, pug_interp;
var pug_indent = [];


































































pug_html = pug_html + "\n\u003Ch3\u003E";

pug_html = pug_html + "Status\u003C\u002Fh3\u003E";

pug_html = pug_html + "\n\u003Cdiv class=\"panopto-scheduler-status\" data-bind=\"with: status\"\u003E";

pug_html = pug_html + "\n  \u003Cdiv class=\"control\"\u003E";

pug_html = pug_html + "\n    \u003Clabel\u003E";

pug_html = pug_html + "Registration Status\u003C\u002Flabel\u003E";

pug_html = pug_html + "\n    \u003Cdiv class=\"status registration-status disabled\" data-bind=\"visible: !enabled\"\u003E";

pug_html = pug_html + "Disabled\u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n    \u003Cdiv class=\"status registration-status not-registered\" data-bind=\"visible: !registered &amp;&amp; enabled\"\u003E";

pug_html = pug_html + "\u003Cspan\u003E";

pug_html = pug_html + "Not Registered\u003C\u002Fspan\u003E";

pug_html = pug_html + "\u003Ci class=\"material-icons failure-icon\"\u003E";

pug_html = pug_html + "highlight_off\u003C\u002Fi\u003E\u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n    \u003Cdiv class=\"status registration-status registered\" data-bind=\"visible: registered\"\u003E";

pug_html = pug_html + "\u003Cspan\u003E\n        ";

pug_html = pug_html + "Registered as:";

pug_html = pug_html + "";

pug_html = pug_html + "\n        ";

pug_html = pug_html + "";

pug_html = pug_html + "\u003Cspan data-bind=\"text: resourceName\"\u003E\u003C\u002Fspan\u003E\u003C\u002Fspan\u003E";

pug_html = pug_html + "\u003Ci class=\"material-icons success-icon\"\u003E";

pug_html = pug_html + "check_circle_outline                \u003C\u002Fi\u003E\u003C\u002Fdiv\u003E\n  \u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n  \u003Cdiv class=\"control\"\u003E";

pug_html = pug_html + "\n    \u003Clabel\u003E";

pug_html = pug_html + "Sync Status\u003C\u002Flabel\u003E";

pug_html = pug_html + "\n    \u003Cdiv class=\"status sync-status\" data-bind=\"css: { success: success, error: !success }\"\u003E";

pug_html = pug_html + "\u003Cspan data-bind=\"text: message\"\u003E\u003C\u002Fspan\u003E";

pug_html = pug_html + "\u003Ci class=\"material-icons failure-icon\"\u003E";

pug_html = pug_html + "highlight_off\u003C\u002Fi\u003E";

pug_html = pug_html + "\u003Ci class=\"material-icons success-icon\"\u003E";

pug_html = pug_html + "check_circle_outline\u003C\u002Fi\u003E\u003C\u002Fdiv\u003E\n  \u003C\u002Fdiv\u003E\n\u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n\u003Cdiv class=\"control\"\u003E";

pug_html = pug_html + "\n  \u003Clabel\u003E";

pug_html = pug_html + "Last Updated\u003C\u002Flabel\u003E";

pug_html = pug_html + "\n  \u003Cdiv class=\"last-updated\" data-bind=\"text: lastUpdated\"\u003E\u003C\u002Fdiv\u003E\n\u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n\u003Ch3\u003E";

pug_html = pug_html + "Panopto Scheduler Configuration\u003C\u002Fh3\u003E";

pug_html = pug_html + "\n\u003Cdiv class=\"control\"\u003E";

pug_html = pug_html + "\n  \u003Clabel\u003E";

pug_html = pug_html + "Panopto URL\u003C\u002Flabel\u003E";

pug_html = pug_html + "\n  \u003Cinput type=\"text\" data-bind=\"value: url\"\u002F\u003E\n\u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n\u003Cdiv class=\"control\"\u003E";

pug_html = pug_html + "\n  \u003Clabel\u003E";

pug_html = pug_html + "Registration Key\u003C\u002Flabel\u003E";

pug_html = pug_html + "\n  \u003Cinput type=\"text\" data-bind=\"value: registrationKey\"\u002F\u003E\n\u003C\u002Fdiv\u003E";return pug_html;}

},{"fs":1,"pug-runtime":"pug-runtime"}]},{},[2])(2)
});
